Subject: Re: [patch 07/10] Page fault handler should not depend on CONFIG_KPROBES

From: Christoph Hellwig <[email-masked]>
Date: Wed, 21 Mar 2007 17:13:42 +0100

On Tue, Mar 20, 2007 at 08:38:17PM -0500, [email-masked] wrote:
> Like x86-64, change the page fault notifier code to not depend on
> CONFIG_KPROBES and export the handlers.

NACK until the performace implication a fixed.  Martin measured this
costs 300 cycles on s390 even without any notifier activce, and while
ppc might be slightly bad that's still too much to add to the pagefault
handler unconditionally.  Please add a light weight method to check
whether there is any activce user of the notifications.  Also please
move the code into kernel/ at the same time instead of having the exact
same thing duplicated all over, as in my notify_die patches.

> +EXPORT_SYMBOL_GPL(register_page_fault_notifier);

> +EXPORT_SYMBOL_GPL(unregister_page_fault_notifier);

Please drop these exports.  There's not modular users of it, and
the target users (kprobes and debuggers) can't be modular either.